Index: branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 492)
+++ branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 494)
@@ -5271,45 +5205,31 @@
             << " / last = "       << last
             << std::endl;
-      }
-#endif
-      break;
-    }
-    ////////////////////////
-    case CLEANUP_HEAP_CLEAN:    // remove a copy in the linked list
-    {
-      if(r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_CLEAN state"
-            << "Bad HEAP allocation"  << std::endl;
-
-        exit(0);
-      }
-
-      HeapEntry heap_entry;
-      heap_entry.owner.srcid    = r_cleanup_prev_srcid.read();
-      heap_entry.owner.inst     = r_cleanup_prev_inst.read();
-
-#if L1_MULTI_CACHE
-      heap_entry.owner.cache_id = r_cleanup_prev_cache_id.read();
-#endif
-
-      bool last = (r_cleanup_next_ptr.read() == r_cleanup_ptr.read());
-
-      // this is the last entry of the list of copies
-      if(last)
-      {
-        heap_entry.next = r_cleanup_prev_ptr.read();
-      }
-      // this is not the last entry
-      else
-      {
-        heap_entry.next = r_cleanup_ptr.read();
-      }
-
-      m_heap.write(r_cleanup_prev_ptr.read(), heap_entry);
-
-      r_cleanup_fsm = CLEANUP_HEAP_FREE;
+}
+#endif
+          break;
+      }
+      ////////////////////////
+      case CLEANUP_HEAP_CLEAN:    // remove a copy in the linked list
+      {
+          assert( (r_alloc_heap_fsm.read() == ALLOC_HEAP_CLEANUP) and
+          "MEMC ERROR in CLEANUP_HEAP_LOCK state: bad HEAP allocation");
+
+          HeapEntry heap_entry;
+          heap_entry.owner.srcid    = r_cleanup_prev_srcid.read();
+          heap_entry.owner.inst     = r_cleanup_prev_inst.read();
+          bool last = (r_cleanup_next_ptr.read() == r_cleanup_ptr.read());
+
+          if (last)     // this is the last entry of the list of copies
+          {
+              heap_entry.next = r_cleanup_prev_ptr.read();
+          }
+          else          // this is not the last entry
+          {
+              heap_entry.next = r_cleanup_ptr.read();
+          }
+
+          m_heap.write(r_cleanup_prev_ptr.read(), heap_entry);
+
+          r_cleanup_fsm = CLEANUP_HEAP_FREE;
 
 #if DEBUG_MEMC_CLEANUP
@@ -5318,42 +5238,31 @@
           << " Remove the copy in the linked list" << std::endl;
 #endif
-      break;
-    }
-    ///////////////////////
-    case CLEANUP_HEAP_FREE:   // The heap entry pointed by r_cleanup_next_ptr is freed
-                              // and becomes the head of the list of free entries
-    {
-      if(r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_CLEAN state" << std::endl
-            << "Bad HEAP allocation" << std::endl;
-
-        exit(0);
-      }
-
-      HeapEntry heap_entry;
-      heap_entry.owner.srcid    = 0;
-      heap_entry.owner.inst     = false;
-
-#if L1_MULTI_CACHE
-      heap_entry.owner.cache_id = 0;
-#endif
-
-      if(m_heap.is_full())
-      {
-        heap_entry.next = r_cleanup_next_ptr.read();
-      }
-      else
-      {
-        heap_entry.next = m_heap.next_free_ptr();
-      }
-
-      m_heap.write(r_cleanup_next_ptr.read(),heap_entry);
-      m_heap.write_free_ptr(r_cleanup_next_ptr.read());
-      m_heap.unset_full();
-
-      r_cleanup_fsm = CLEANUP_SEND_CLACK;
+          break;
+      }
+      ///////////////////////
+      case CLEANUP_HEAP_FREE:   // The heap entry pointed by r_cleanup_next_ptr is freed
+                                // and becomes the head of the list of free entries
+      {
+          assert( (r_alloc_heap_fsm.read() == ALLOC_HEAP_CLEANUP) and
+          "MEMC ERROR in CLEANUP_HEAP_LOCK state: bad HEAP allocation");
+
+          HeapEntry heap_entry;
+          heap_entry.owner.srcid    = 0;
+          heap_entry.owner.inst     = false;
+
+          if(m_heap.is_full())
+          {
+              heap_entry.next = r_cleanup_next_ptr.read();
+          }
+          else
+          {
+              heap_entry.next = m_heap.next_free_ptr();
+          }
+
+          m_heap.write(r_cleanup_next_ptr.read(),heap_entry);
+          m_heap.write_free_ptr(r_cleanup_next_ptr.read());
+          m_heap.unset_full();
+
+          r_cleanup_fsm = CLEANUP_SEND_CLACK;
 
 #if DEBUG_MEMC_CLEANUP
@@ -5362,17 +5271,16 @@
           << " Update the list of free entries" << std::endl;
 #endif
-      break;
-    }
-    //////////////////////
-    case CLEANUP_IVT_LOCK:   // get the lock protecting the IVT to search a pending
-                             // invalidate transaction matching the cleanup 
-    {
-      m_cpt_cleanup_fsm_upt_lock++;
-      if(r_alloc_ivt_fsm.read() != ALLOC_IVT_CLEANUP) break;
-
-      size_t index = 0;
-      bool   match_inval;
-
-      match_inval = m_ivt.search_inval(r_cleanup_nline.read(), index);
+          break;
+      }
+      //////////////////////
+      case CLEANUP_IVT_LOCK:   // get the lock protecting the IVT to search a pending
+                               // invalidate transaction matching the cleanup 
+      {
+          if(r_alloc_ivt_fsm.read() != ALLOC_IVT_CLEANUP) break;
+
+          size_t index = 0;
+          bool   match_inval;
+
+          match_inval = m_ivt.search_inval(r_cleanup_nline.read(), index);
 
       if ( not match_inval )     // no pending inval
@@ -5390,68 +5298,56 @@
 #if DEBUG_MEMC_CLEANUP
 if(m_debug)
-std::cout << "  <MEMC " << name()
-          << " CLEANUP_IVT_LOCK> Unexpected cleanup"
-          << " with no corresponding IVT entry:"
-          << " address = " << std::hex
-          << (r_cleanup_nline.read() *4*m_words)
-          << std::endl;
-#endif
-      m_cpt_cleanup_fsm_n_upt_lock++;
-        break;
-      }
-
-      // pending inval
-      r_cleanup_write_srcid = m_ivt.srcid(index);
-      r_cleanup_write_trdid = m_ivt.trdid(index);
-      r_cleanup_write_pktid = m_ivt.pktid(index);
-      r_cleanup_need_rsp    = m_ivt.need_rsp(index);
-      r_cleanup_need_ack    = m_ivt.need_ack(index);
-      r_cleanup_index       = index;
-
-      r_cleanup_fsm         = CLEANUP_IVT_DECREMENT;
+std::cout << "  <MEMC " << name() << " CLEANUP_IVT_LOCK>" 
+          << " Unexpected cleanup with no corresponding IVT entry:"
+          << " address = " << std::hex << (r_cleanup_nline.read()*4*m_words) << std::endl;
+#endif
+        break;
+      }
+      else                     // pending inval in IVT
+      {
+        r_cleanup_write_srcid = m_ivt.srcid(index);
+        r_cleanup_write_trdid = m_ivt.trdid(index);
+        r_cleanup_write_pktid = m_ivt.pktid(index);
+        r_cleanup_need_rsp    = m_ivt.need_rsp(index);
+        r_cleanup_need_ack    = m_ivt.need_ack(index);
+        r_cleanup_index       = index;
+        r_cleanup_fsm         = CLEANUP_IVT_DECREMENT;
 
 #if DEBUG_MEMC_CLEANUP
-if(m_debug)
-std::cout << "  <MEMC " << name()
-          << " CLEANUP_IVT_LOCK> Cleanup matching pending"
-          << " invalidate transaction on IVT:"
-          << " address = " << std::hex << r_cleanup_nline.read() * m_words * 4
-          << " / ivt_entry = " << index << std::endl;
-#endif
+        if(m_debug)
+          std::cout << "  <MEMC " << name() << " CLEANUP_IVT_LOCK>"
+            << " Cleanup matching pending invalidate transaction on IVT:"
+            << " address = " << std::hex << (r_cleanup_nline.read()*m_words*4) 
+            << " / ivt_entry = " << index << std::endl;
+#endif
+      }
       break;
-    }
-    ///////////////////////////
-    case CLEANUP_IVT_DECREMENT: // decrement response counter in IVT matching entry
-    {
-      if(r_alloc_ivt_fsm.read() != ALLOC_IVT_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR "         << name()
-            << " CLEANUP_IVT_DECREMENT state" << std::endl
-            << "Bad IVT allocation"
-            << std::endl;
-
-        exit(0);
-      }
-
-      size_t count = 0;
-      m_ivt.decrement(r_cleanup_index.read(), count);
-
-      if(count == 0)   // multi inval transaction completed
-      {
-        r_cleanup_fsm = CLEANUP_IVT_CLEAR;
-      }
-      else             // multi inval transaction not completed
-      {
-        /*ODCCP*/ // If cleanup is on no coherent line we go to CLEANUP_IXR_REQ
-        if (r_cleanup_ncc.read())
-        {
-          r_cleanup_fsm = CLEANUP_IXR_REQ;
-        }
-        else
-        {
-          r_cleanup_fsm = CLEANUP_SEND_CLACK;
-        }
-      }
+      }
+      ///////////////////////////
+      case CLEANUP_IVT_DECREMENT: // decrement response counter in IVT matching entry
+                                  // and test if last 
+      {
+          assert( (r_alloc_ivt_fsm.read() == ALLOC_IVT_CLEANUP) and
+          "MEMC ERROR in CLEANUP_IVT_DECREMENT state: Bad IVT allocation");
+
+          size_t count = 0;
+          m_ivt.decrement(r_cleanup_index.read(), count);
+
+          if(count == 0)   // multi inval transaction completed
+          {
+            r_cleanup_fsm = CLEANUP_IVT_CLEAR;
+          }
+          else             // multi inval transaction not completed
+          {
+            /*ODCCP*/ // If cleanup is on no coherent line we go to CLEANUP_IXR_REQ
+            if (r_cleanup_ncc.read())
+            {
+              r_cleanup_fsm = CLEANUP_IXR_REQ;
+            }
+            else
+            {
+              r_cleanup_fsm = CLEANUP_SEND_CLACK;
+            }
+          }
 
 #if DEBUG_MEMC_CLEANUP
@@ -5459,27 +5355,27 @@
 std::cout << "  <MEMC " << name() << " CLEANUP_IVT_DECREMENT>"
           << " Decrement response counter in IVT:"
-            << " IVT_index = " << r_cleanup_index.read()
-            << " / rsp_count = " << count << std::endl;
-#endif
-      break;
-    }
-    ///////////////////////
-    case CLEANUP_IVT_CLEAR:    // Clear IVT entry 
-    {
-      if(r_alloc_ivt_fsm.read() != ALLOC_IVT_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR "     << name()
-            << " CLEANUP_IVT_CLEAR state" << std::endl
-            << "Bad IVT allocation"
-            << std::endl;
-
-        exit(0);
-      }
-
-      m_ivt.clear(r_cleanup_index.read());
+          << " IVT_index = " << r_cleanup_index.read()
+          << " / rsp_count = " << count << std::endl;
+#endif
+          break;
+      }
+      ///////////////////////
+      case CLEANUP_IVT_CLEAR:    // Clear IVT entry 
+                                 // Acknowledge CONFIG FSM if required 
+      {
+          assert( (r_alloc_ivt_fsm.read() == ALLOC_IVT_CLEANUP) and
+          "MEMC ERROR in CLEANUP_IVT_CLEAR state : bad IVT allocation");
+
+          m_ivt.clear(r_cleanup_index.read());
+
+          if ( r_cleanup_need_ack.read() )
+          {
+              assert( (r_config_rsp_lines.read() > 0) and
+              "MEMC ERROR in CLEANUP_IVT_CLEAR state");
+   
+              r_config_rsp_lines = r_config_rsp_lines.read() - 1;
+          }
 
       if      ( r_cleanup_need_rsp.read() ) r_cleanup_fsm = CLEANUP_WRITE_RSP;
-      else if ( r_cleanup_need_ack.read() ) r_cleanup_fsm = CLEANUP_CONFIG_ACK;
       else if ( r_cleanup_ncc.read()      ) r_cleanup_fsm = CLEANUP_IXR_REQ;
       else                                  r_cleanup_fsm = CLEANUP_SEND_CLACK;
@@ -5491,27 +5387,27 @@
           << " IVT_index = " << r_cleanup_index.read() << std::endl;
 #endif
-      break;
-    }
-    ///////////////////////
-    case CLEANUP_WRITE_RSP:    // response to a previous write on the direct network
+          break;
+      }
+      ///////////////////////
+      case CLEANUP_WRITE_RSP:    // response to a previous write on the direct network
                                // wait if pending request to the TGT_RSP FSM
-    {
-      if(r_cleanup_to_tgt_rsp_req.read()) break;
-
-      // no pending request
-      r_cleanup_to_tgt_rsp_req     = true;
-      r_cleanup_to_tgt_rsp_srcid   = r_cleanup_write_srcid.read();
-      r_cleanup_to_tgt_rsp_trdid   = r_cleanup_write_trdid.read();
-      r_cleanup_to_tgt_rsp_pktid   = r_cleanup_write_pktid.read();
-
-      /*ODCCP*/ // If cleanup is on no coherent line we go to CLEANUP_IXR_REQ
-      if (r_cleanup_ncc.read())
-      {
-        r_cleanup_fsm = CLEANUP_IXR_REQ;
-      }
-      else
-      {
-        r_cleanup_fsm = CLEANUP_SEND_CLACK;
-      }
+      {
+          if(r_cleanup_to_tgt_rsp_req.read()) break;
+
+          // no pending request
+          r_cleanup_to_tgt_rsp_req     = true;
+          r_cleanup_to_tgt_rsp_srcid   = r_cleanup_write_srcid.read();
+          r_cleanup_to_tgt_rsp_trdid   = r_cleanup_write_trdid.read();
+          r_cleanup_to_tgt_rsp_pktid   = r_cleanup_write_pktid.read();
+
+          /*ODCCP*/ // If cleanup is on no coherent line we go to CLEANUP_IXR_REQ
+          if (r_cleanup_ncc.read())
+          {
+            r_cleanup_fsm = CLEANUP_IXR_REQ;
+          }
+          else
+          {
+            r_cleanup_fsm = CLEANUP_SEND_CLACK;
+          }
 
 #if DEBUG_MEMC_CLEANUP
@@ -5523,21 +5419,6 @@
           << " / rpktid = " << r_cleanup_write_pktid.read() << std::endl;
 #endif
-      break;
-    }
-    ////////////////////////
-    case CLEANUP_CONFIG_ACK:   // signals inval completion to CONFIG FSM
-                               // wait if pending request
-    {
-      if ( r_cleanup_to_config_ack.read() ) break;
-      r_cleanup_to_config_ack      = true;
-      r_cleanup_fsm                = CLEANUP_SEND_CLACK;
-
-#if DEBUG_MEMC_CLEANUP
-if(m_debug)
-std::cout << "  <MEMC " << name() << " CLEANUP_CONFIG_ACK>"
-          << " Acknowledge broacast inval completion" << std::endl;
-#endif
-      break;
-    }
+          break;
+      }
 
     /*ODCCP*/ 
@@ -5560,5 +5441,5 @@
             r_cleanup_to_ixr_cmd_req          = r_cleanup_contains_data.read();
             r_cleanup_to_ixr_cmd_srcid        = r_cleanup_srcid.read();
-            r_cleanup_to_ixr_cmd_trdid        = m_trt_lines;
+            r_cleanup_to_ixr_cmd_index        = m_trt_lines;
             r_cleanup_to_ixr_cmd_pktid        = r_cleanup_pktid.read();
             r_cleanup_to_ixr_cmd_nline        = r_cleanup_nline.read();
@@ -5604,5 +5485,5 @@
           }
           r_cleanup_to_ixr_cmd_srcid        = r_cleanup_srcid.read();
-          r_cleanup_to_ixr_cmd_trdid        = index;
+          r_cleanup_to_ixr_cmd_index        = index;
           r_cleanup_to_ixr_cmd_pktid        = r_cleanup_pktid.read();
           r_cleanup_to_ixr_cmd_nline        = r_cleanup_nline.read();
@@ -5652,11 +5533,11 @@
 std::cout << "  <MEMC " << name()
           << " CLEANUP_SEND_CLACK> Send the response to a cleanup request:"
-          << " nline = "   << std::hex << r_cleanup_nline.read()
+          << " address = "   << std::hex << r_cleanup_nline.read()*m_words*4
           << " / way = "   << std::dec << r_cleanup_way.read()
           << " / srcid = " << std::dec << r_cleanup_srcid.read() 
           << std::endl;
 #endif
-      break;
-    }
+          break;
+      }
   } // end switch cleanup fsm
 
@@ -5664,12 +5545,11 @@
   //    CAS FSM
   ////////////////////////////////////////////////////////////////////////////////////
-  // The CAS FSM handles the CAS (Store Conditionnal) atomic commands,
-  // that are handled as "compare-and-swap instructions.
+  // The CAS FSM handles the CAS (Compare And Swap) atomic commands.
   //
   // This command contains two or four flits:
   // - In case of 32 bits atomic access, the first flit contains the value read
-  // by a previous LL instruction, the second flit contains the value to be writen.
+  // by a previous READ instruction, the second flit contains the value to be writen.
   // - In case of 64 bits atomic access, the 2 first flits contains the value read
-  // by a previous LL instruction, the 2 next flits contains the value to be writen.
+  // by a previous READ instruction, the 2 next flits contains the value to be writen.
   //
   // The target address is cachable. If it is replicated in other L1 caches
@@ -5678,90 +5558,78 @@
   // It access the directory to check hit / miss.
   // - In case of miss, the CAS FSM must register a GET transaction in TRT.
-  // If a read transaction to the XRAM for this line already exists,
-  // or if the transaction table is full, it goes to the WAIT state
-  // to release the locks and try again. When the GET transaction has been
-  // launched, it goes to the WAIT state and try again.
-  // The CAS request is not consumed in the FIFO until a HIT is obtained.
+  //   If a read transaction to the XRAM for this line already exists,
+  //   or if the transaction table is full, it goes to the WAIT state
+  //   to release the locks and try again. When the GET transaction has been
+  //   launched, it goes to the WAIT state and try again.
+  //   The CAS request is not consumed in the FIFO until a HIT is obtained.
   // - In case of hit...
   ///////////////////////////////////////////////////////////////////////////////////
 
+//std::cout << std::endl << "cas_fsm" << std::endl;
+
   switch(r_cas_fsm.read())
   {
-      /////////////
+    ////////////
     case CAS_IDLE:     // fill the local rdata buffers
     {
-      if(m_cmd_cas_addr_fifo.rok())
-      {
+        if (m_cmd_cas_addr_fifo.rok() )
+        {
 
 #if DEBUG_MEMC_CAS
-        if(m_debug)
-        {
-          std::cout << "  <MEMC " << name() << " CAS_IDLE> CAS command: " << std::hex
-                    << " srcid = " <<  std::dec << m_cmd_cas_srcid_fifo.read()
-                    << " addr = " << std::hex << m_cmd_cas_addr_fifo.read()
-                    << " wdata = " << m_cmd_cas_wdata_fifo.read()
-                    << " eop = " << std::dec << m_cmd_cas_eop_fifo.read()
-                    << " cpt  = " << std::dec << r_cas_cpt.read() << std::endl;
-        }
-#endif
-        if(m_cmd_cas_eop_fifo.read())
-        {
-          m_cpt_cas++;
-          r_cas_fsm = CAS_DIR_REQ;
-        }
-        else  // we keep the last word in the FIFO
-        {
-          cmd_cas_fifo_get = true;
-        }
-        // We fill the two buffers
-        if(r_cas_cpt.read() < 2)    // 32 bits access
-          r_cas_rdata[r_cas_cpt.read()] = m_cmd_cas_wdata_fifo.read();
-
-        if((r_cas_cpt.read() == 1) and m_cmd_cas_eop_fifo.read())
-          r_cas_wdata = m_cmd_cas_wdata_fifo.read();
-
-        if(r_cas_cpt.read() >3)  // more than 4 flits...
-        {
-          std::cout << "VCI_MEM_CACHE ERROR in CAS_IDLE state : illegal CAS command"
-                    << std::endl;
-          exit(0);
-        }
-
-        if(r_cas_cpt.read() ==2)
-          r_cas_wdata = m_cmd_cas_wdata_fifo.read();
-
-        r_cas_cpt = r_cas_cpt.read() +1;
-      }
-      break;
-    }
-
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_IDLE> CAS command: " << std::hex
+          << " srcid = " <<  std::dec << m_cmd_cas_srcid_fifo.read()
+          << " addr = " << std::hex << m_cmd_cas_addr_fifo.read()
+          << " wdata = " << m_cmd_cas_wdata_fifo.read()
+          << " eop = " << std::dec << m_cmd_cas_eop_fifo.read()
+          << " cpt  = " << std::dec << r_cas_cpt.read() << std::endl;
+#endif
+            if(m_cmd_cas_eop_fifo.read())
+            {
+                m_cpt_cas++;
+                r_cas_fsm = CAS_DIR_REQ;
+            }
+            else  // we keep the last word in the FIFO
+            {
+                cmd_cas_fifo_get = true;
+            }
+
+            // We fill the two buffers
+            if(r_cas_cpt.read() < 2)    // 32 bits access
+                r_cas_rdata[r_cas_cpt.read()] = m_cmd_cas_wdata_fifo.read();
+
+            if((r_cas_cpt.read() == 1) and m_cmd_cas_eop_fifo.read())
+                r_cas_wdata = m_cmd_cas_wdata_fifo.read();
+
+            assert( (r_cas_cpt.read() <= 3) and  // no more than 4 flits...
+            "MEMC ERROR in CAS_IDLE state: illegal CAS command");
+
+            if(r_cas_cpt.read() ==2)
+                r_cas_wdata = m_cmd_cas_wdata_fifo.read();
+
+            r_cas_cpt = r_cas_cpt.read() +1;
+        }
+        break;
+    }
     /////////////////
     case CAS_DIR_REQ:
     {
-      if(r_alloc_dir_fsm.read() == ALLOC_DIR_CAS)
-      {
-        r_cas_fsm = CAS_DIR_LOCK;
-        m_cpt_cas_fsm_n_dir_lock++;
-      }
+        if(r_alloc_dir_fsm.read() == ALLOC_DIR_CAS)
+        {
+            r_cas_fsm = CAS_DIR_LOCK;
+        }
 
 #if DEBUG_MEMC_CAS
-      if(m_debug)
-      {
-        std::cout
-            << "  <MEMC " << name() << " CAS_DIR_REQ> Requesting DIR lock "
-            << std::endl;
-      }
-#endif
-
-      m_cpt_cas_fsm_dir_lock++;
-
-      break;
-    }
-
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_DIR_REQ> Requesting DIR lock " << std::endl;
+#endif
+        break;
+    }
     /////////////////
     case CAS_DIR_LOCK:  // Read the directory
     {
-      if(r_alloc_dir_fsm.read() == ALLOC_DIR_CAS)
-      {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS) and
+        "MEMC ERROR in CAS_DIR_LOCK: Bad DIR allocation");
+
         size_t way = 0;
         DirectoryEntry entry(m_cache_directory.read(m_cmd_cas_addr_fifo.read(), way));
@@ -5772,7 +5640,4 @@
         r_cas_way        = way;
         r_cas_copy       = entry.owner.srcid;
-#if L1_MULTI_CACHE
-        r_cas_copy_cache = entry.owner.cache_id;
-#endif
         r_cas_copy_inst  = entry.owner.inst;
         r_cas_ptr        = entry.ptr;
@@ -5783,25 +5648,13 @@
 
 #if DEBUG_MEMC_CAS
-        if(m_debug)
-        {
-          std::cout << "  <MEMC " << name() << " CAS_DIR_LOCK> Directory acces"
-                    << " / address = " << std::hex << m_cmd_cas_addr_fifo.read()
-                    << " / hit = " << std::dec << entry.valid
-                    << " / count = " << entry.count
-                    << " / is_cnt = " << entry.is_cnt << std::endl;
-        }
-#endif
-      }
-      else
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CAS_DIR_LOCK state" << std::endl
-            << "Bad DIR allocation"   << std::endl;
-
-        exit(0);
-      }
-
-      break;
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_DIR_LOCK> Directory acces"
+          << " / address = " << std::hex << m_cmd_cas_addr_fifo.read()
+          << " / hit = " << std::dec << entry.valid
+          << " / count = " << entry.count
+          << " / is_cnt = " << entry.is_cnt << std::endl;
+#endif
+
+        break;
     }
     /////////////////////
@@ -5809,28 +5662,28 @@
                             // and check data change in cache
     {
-      size_t way  = r_cas_way.read();
-      size_t set  = m_y[(addr_t)(m_cmd_cas_addr_fifo.read())];
-
-      // update directory (lock & dirty bits)
-      DirectoryEntry entry;
-      entry.valid          = true;
-      entry.is_cnt         = r_cas_is_cnt.read();
-      entry.dirty          = true;
-      entry.lock           = true;
-      entry.tag            = r_cas_tag.read();
-      entry.owner.srcid    = r_cas_copy.read();
-#if L1_MULTI_CACHE
-      entry.owner.cache_id = r_cas_copy_cache.read();
-#endif
-      entry.owner.inst     = r_cas_copy_inst.read();
-      entry.count          = r_cas_count.read();
-      entry.ptr            = r_cas_ptr.read();
-
-      m_cache_directory.write(set, way, entry);
-
-      // Stored data from cache in buffer to do the comparison in next state
-      m_cache_data.read_line(way, set, r_cas_data);
-
-      r_cas_fsm = CAS_DIR_HIT_COMPARE;
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS) and
+        "MEMC ERROR in CAS_DIR_HIT_READ: Bad DIR allocation");
+
+        size_t way  = r_cas_way.read();
+        size_t set  = m_y[(addr_t)(m_cmd_cas_addr_fifo.read())];
+
+        // update directory (lock & dirty bits)
+        DirectoryEntry entry;
+        entry.valid          = true;
+        entry.is_cnt         = r_cas_is_cnt.read();
+        entry.dirty          = true;
+        entry.lock           = true;
+        entry.tag            = r_cas_tag.read();
+        entry.owner.srcid    = r_cas_copy.read();
+        entry.owner.inst     = r_cas_copy_inst.read();
+        entry.count          = r_cas_count.read();
+        entry.ptr            = r_cas_ptr.read();
+
+        m_cache_directory.write(set, way, entry);
+
+        // Store data from cache in buffer to do the comparison in next state
+        m_cache_data.read_line(way, set, r_cas_data);
+
+        r_cas_fsm = CAS_DIR_HIT_COMPARE;
 
 #if DEBUG_MEMC_CAS
@@ -5839,12 +5692,12 @@
           << " cache and store it in buffer" << std::endl;
 #endif
-      break;
-    }
-
+        break;
+    }
+    ////////////////////////
     case CAS_DIR_HIT_COMPARE:
     {
-      size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
-
-      // Read data in buffer & check data change
+        size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
+
+        // check data change
       bool ok = (r_cas_rdata[0].read() == r_cas_data[word].read());
 
@@ -5856,22 +5709,13 @@
       r_cas_lfsr = (r_cas_lfsr >> 1) ^ ((- (r_cas_lfsr & 1)) & 0xd0000001);
 
-      // cas success
-      if(ok and not forced_fail)
-      {
-        r_cas_fsm = CAS_DIR_HIT_WRITE;
-      }
-      // cas failure
-      else
-      {
-        r_cas_fsm = CAS_RSP_FAIL;
-      }
+      if(ok and not forced_fail) r_cas_fsm = CAS_DIR_HIT_WRITE; 
+      else                       r_cas_fsm = CAS_RSP_FAIL; 
 
 #if DEBUG_MEMC_CAS
 if(m_debug)
-std::cout << "  <MEMC " << name() << " CAS_DIR_HIT_COMPARE> Compare the old"
-          << " and the new data"
-          << " / expected value = " << r_cas_rdata[0].read()
-          << " / actual value = "   << r_cas_data[word].read()
-          << " / forced_fail = "    << forced_fail << std::endl;
+std::cout << "  <MEMC " << name() << " CAS_DIR_HIT_COMPARE> Compare old and new data"
+          << " / expected value = " << std::hex << r_cas_rdata[0].read()
+          << " / actual value = "   << std::hex << r_cas_data[word].read()
+          << " / forced_fail = "    << std::dec << forced_fail << std::endl;
 #endif
       break;
@@ -5879,48 +5723,63 @@
     //////////////////////
     case CAS_DIR_HIT_WRITE:    // test if a CC transaction is required
-      // write data in cache if no CC request
-    {
-      // The CAS is a success => sw access to the llsc_global_table
-      m_llsc_table.sw(m_nline[(addr_t)m_cmd_cas_addr_fifo.read()],m_x[(addr_t)(m_cmd_cas_addr_fifo.read())],m_x[(addr_t)(m_cmd_cas_addr_fifo.read())]);
-
-      // test coherence request
-      if(r_cas_count.read())   // replicated line
-      {
-        if(r_cas_is_cnt.read())
-        {
-          r_cas_fsm = CAS_BC_TRT_LOCK;    // broadcast invalidate required
-        }
-        else if(!r_cas_to_cc_send_multi_req.read() and
-                !r_cas_to_cc_send_brdcast_req.read())
-        {
-          r_cas_fsm = CAS_UPT_LOCK;       // multi update required
-        }
-        else
-        {
-          r_cas_fsm = CAS_WAIT;
-        }
-      }
-      else                    // no copies
-      {
-        size_t way  = r_cas_way.read();
-        size_t set  = m_y[(addr_t)(m_cmd_cas_addr_fifo.read())];
-        size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
-
-        // cache update
-        m_cache_data.write(way, set, word, r_cas_wdata.read());
-        if(r_cas_cpt.read() == 4)
-          m_cache_data.write(way, set, word+1, m_cmd_cas_wdata_fifo.read());
-
-        r_cas_fsm = CAS_RSP_SUCCESS;
-
-        // monitor
-        if(m_monitor_ok)
-        {
-          addr_t address = m_cmd_cas_addr_fifo.read();
-          check_monitor( address, r_cas_wdata.read(), false);
-
-          if(r_cas_cpt.read() == 4)
-            check_monitor( address+4, m_cmd_cas_wdata_fifo.read(), false);
-        }
+                               // write data in cache if no CC request
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS) and
+        "MEMC ERROR in CAS_DIR_HIT_WRITE: Bad DIR allocation");
+
+        // The CAS is a success => sw access to the llsc_global_table
+        m_llsc_table.sw( m_nline[(addr_t)m_cmd_cas_addr_fifo.read()],
+                         m_x[(addr_t)(m_cmd_cas_addr_fifo.read())],
+                         m_x[(addr_t)(m_cmd_cas_addr_fifo.read())] );
+
+        // test coherence request
+        if(r_cas_count.read())   // replicated line
+        {
+            if(r_cas_is_cnt.read())
+            {
+                r_cas_fsm = CAS_BC_TRT_LOCK;    // broadcast invalidate required
+
+#if DEBUG_MEMC_CAS
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_DIR_HIT_WRITE>"
+          << " Broacast Inval required" 
+          << " / copies = " << r_cas_count.read() << std::endl;
+#endif
+            }
+            else if( not r_cas_to_cc_send_multi_req.read() and
+                     not r_cas_to_cc_send_brdcast_req.read() )
+            {
+                r_cas_fsm = CAS_UPT_LOCK;       // multi update required
+
+#if DEBUG_MEMC_CAS
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_DIR_HIT_WRITE>"
+          << " Multi Inval required" 
+          << " / copies = " << r_cas_count.read() << std::endl;
+#endif
+            }
+            else
+            {
+                r_cas_fsm = CAS_WAIT;
+
+#if DEBUG_MEMC_CAS
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_DIR_HIT_WRITE>"
+          << " CC_SEND FSM busy: release all locks and retry" << std::endl;
+#endif
+            }
+        }
+        else                    // no copies
+        {
+            size_t way  = r_cas_way.read();
+            size_t set  = m_y[(addr_t)(m_cmd_cas_addr_fifo.read())];
+            size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
+
+            // cache update
+            m_cache_data.write(way, set, word, r_cas_wdata.read());
+            if(r_cas_cpt.read() == 4)
+            m_cache_data.write(way, set, word+1, m_cmd_cas_wdata_fifo.read());
+
+            r_cas_fsm = CAS_RSP_SUCCESS;
 
 #if DEBUG_MEMC_CAS
